## opencpn 5.12.2+dfsg

=== libs/IXWebSocket/ws/CMakeLists.txt ===
#
# Author: Benjamin Sergeant
# Copyright (c) 2019 Machine Zone, Inc. All rights reserved.
#

cmake_minimum_required (VERSION 3.14)
project (ws)

# There's -Weverything too for clang
if (NOT WIN32)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -pedantic")
endif()

set (CMAKE_CXX_STANDARD 11)

option(USE_TLS "Add TLS support" ON)

include_directories(ws .)
include_directories(ws ..)
include_directories(ws ../third_party/cpp-linenoise)
include_directories(ws ../third_party/cli11)
include_directories(ws ../third_party/msgpack11)

include(FetchContent)

add_executable(ws
  ../third_party/msgpack11/msgpack11.cpp
  ../third_party/cpp-linenoise/linenoise.cpp
  ws.cpp)

# library with the most dependencies come first
target_link_libraries(ws ixwebsocket)

target_link_libraries(ws spdlog)

install(TARGETS ws RUNTIME DESTINATION bin)

=== debian/changelog ===
opencpn (1:5.12.2+dfsg-3~bpo13+1) trixie-backports; urgency=medium

  * Trixie backport of current sid version

 -- Alec Leamas <leamas.alec@gmail.com>  Tue, 26 Aug 2025 20:24:40 +0200

opencpn (1:5.12.2+dfsg-3) unstable; urgency=medium

  * Completely disable tests on unused and untestable arches

 -- Alec Leamas <leamas.alec@gmail.com>  Tue, 12 Aug 2025 21:02:51 +0200

opencpn (1:5.12.2+dfsg-2) unstable; urgency=medium

  * New patch: Remove some useless and failing tests.

 -- Alec Leamas <leamas.alec@gmail.com>  Mon, 11 Aug 2025 15:05:07 +0200

opencpn (1:5.12.2+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Drop upstreamed patches:
     - 0007-chartdldr-Don-t-use-unarr-for-libarchive-3.7.4-4005.patch
  * Rebase other patches
  * Update d/copyright to reflect new source
  * lintian-overrides: drop obsolete entries, add new for appstreamcli
  * d/opencpn-data-install: Authors.html -> authors.html

 -- Alec Leamas <leamas.alec@gmail.com>  Sun, 10 Aug 2025 21:35:45 +0200

=== debian/control ===
Source: opencpn
Maintainer: Alec Leamas <leamas.alec@gmail.com>
Section: misc
Priority: optional
Build-Depends: debhelper-compat (= 13),
 asciidoc-base,
 cmake,
 dbus-daemon,
 git,
 googletest,
 libarchive-dev,
 libbz2-dev,
 libcurl4-openssl-dev,
 libcxx-serial-dev,
 libdrm-dev,
 libelf-dev,
 libexif-dev,
 libgdk-pixbuf-2.0-dev,
 libglew-dev,
 libgtk-3-dev,
 libjs-highlight.js,
 libjs-mathjax,
 liblz4-dev,
 liblzma-dev,
 libpango1.0-dev,
 libshp-dev,
 libsqlite3-dev,
 libssl-dev,
 libtinyxml-dev,
 libudev-dev,
 libusb-1.0-0-dev,
 libwxsvg-dev (>= 2:1.5.21),
 libwxgtk3.2-dev,
 libwxgtk-webview3.2-dev,
 lsb-release,
 portaudio19-dev,
 rapidjson-dev
Standards-Version: 4.7.0
Vcs-Browser: https://github.com/opencpn/opencpn
Vcs-Git: https://github.com/opencpn/opencpn.git -b debian/trixie-backports
Homepage: https://opencpn.org
Rules-Requires-Root: no

Package: opencpn
Architecture: any
Depends: opencpn-data (>= ${source:Version}),
 bzip2,
 libjs-mathjax,
 libjs-highlight.js,
 ${shlibs:Depends},
 ${misc:Depends}
Recommends: wx3.2-i18n, xdg-utils, libusb-0.1-4,
 opencpn-sglock-amd64[amd64],
 opencpn-sglock-arm64[arm64],
 opencpn-sglock-arm32[arm32]
Suggests: binutils
Breaks: opencpn-plugins (<< 4.8.8~),
 opencpn-gshhs-crude (<< 1:1),
 opencpn-tcdata (<< 1:1)
Replaces: opencpn-plugins (<< 4.8.8~),
 opencpn-gshhs-crude(<< 1:1),
 opencpn-tcdata(<< 1:1)
Description: Open Source Chartplotter and Marine GPS Navigation Software
 Chart Plotter and Navigational software program for use underway
 or as a planning tool. Developed by a team of active sailors using real
 world conditions for program testing and refinement.
 By default supports raster and vector formats like BSB and S63. Support for
 many other formats are available in plugins. Other plugins provides
 support for e. g., AIS, radar and weather maps.
 Application has language support in 20+ languages.
 .
 This package contains programs, libraries and some support files.

Package: opencpn-data
Architecture: all
Multi-Arch: foreign
Breaks: opencpn (<< 1:1)
Replaces: opencpn (<< 1:1)
Depends: ${misc:Depends}
Description: Open Source Chartplotter and Marine GPS Navigation Software (data)
 Chart Plotter and Navigational software program for use underway
 or as a planning tool. Developed by a team of active sailors using real
 world conditions for program testing and refinement.
 By default supports raster and vector formats like BSB and S63. Support for
 many other formats are available in plugins. Other plugins provides
 support for e. g., AIS, radar and weather maps.
 Application has language support in 20+ languages.
 .
 This package contains architecture independent data files.

## opencpn 5.12.4%2Bdfsg

=== cli/CMakeLists.txt ===
# ************************************************************************
#  Copyright (C) 2023 Alec Leamas                                        *
#  Copyright (C) 2010 David S Register                                   *
#                                                                        *
#  This program is free software; you can redistribute it and/or modify  *
#  it under the terms of the GNU General Public License as published by  *
#  the Free Software Foundation; either version 2 of the License, or     *
#  (at your option) any later version.                                   *
#                                                                        .
#  This program is distributed in the hope that it will be useful,       *
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        *
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
#  GNU General Public License for more details.                          *
#                                                                        *
#  You should have received a copy of the GNU General Public License     *
#  along with this program; if not, write to the                         *
#  Free Software Foundation, Inc.,                                       *
#  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,  USA.         *
# ************************************************************************


set(SRC_CONSOLE console.cpp api_shim.cpp)
add_executable(opencpn-cmd ${SRC_CONSOLE})
set_property(TARGET opencpn-cmd PROPERTY ENABLE_EXPORTS ON)
if (NOT "${ENABLE_SANITIZER}" MATCHES "none")
  target_link_libraries(opencpn-cmd PRIVATE -fsanitize=${ENABLE_SANITIZER})
endif ()

target_include_directories(
  opencpn-cmd
    PRIVATE
      ${PROJECT_SOURCE_DIR}/include
      # ${PROJECT_SOURCE_DIR}/test/include
      #      ${PROJECT_SOURCE_DIR}/model/include
      ${PROJECT_SOURCE_DIR}/gui/include
)

target_compile_definitions(opencpn-cmd PUBLIC USE_MOCK_DEFS)
if (MSVC)
  target_link_libraries(opencpn-cmd PRIVATE setupapi.lib psapi.lib)
endif ()

if (TARGET ocpn::wxcurl)
  target_link_libraries(opencpn-cmd PRIVATE ocpn::wxcurl)
else ()
  target_link_libraries(opencpn-cmd PRIVATE ${SYS_WXCURL_LIBRARIES})
endif ()

target_link_libraries(opencpn-cmd PRIVATE ${wxWidgets_LIBRARIES})
if (TARGET ocpn::wxsvg)
  target_link_libraries(opencpn-cmd PRIVATE ocpn::wxsvg)
endif ()


target_link_libraries(opencpn-cmd PRIVATE ocpn::serial)
target_link_libraries(opencpn-cmd PRIVATE ocpn::tinyxml)
target_link_libraries(opencpn-cmd PRIVATE ocpn::filesystem)

if (HAVE_LIBUDEV)
  target_link_libraries(opencpn-cmd PRIVATE ocpn::libudev)
endif ()

if(APPLE AND OCPN_USE_DEPS_BUNDLE)
  target_include_directories(
    opencpn-cmd PUBLIC ${OCPN_DEPS_BUNDLE_PATH}/include
  )
endif()

target_link_libraries(opencpn-cmd PRIVATE ocpn::model ocpn::model-src)
if (MSVC)
  target_link_libraries(opencpn-cmd PRIVATE  iphlpapi)
endif ()


if (WIN32)
  install(TARGETS opencpn-cmd RUNTIME DESTINATION ".")
else()
  install(TARGETS opencpn-cmd RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif ()

if (APPLE)
  install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/opencpn-cmd
    DESTINATION "bin/OpenCPN.app/Contents/MacOS"
    PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ
      WORLD_EXECUTE GROUP_EXECUTE OWNER_EXECUTE
  )
  set_target_properties(opencpn-cmd PROPERTIES
                               XCODE_ATTRIBUTE_ENABLE_HARDENED_RUNTIME YES
  )
endif ()

=== libs/android_jvm/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.0)

if (TARGET ocpn::java-jvm)
  return ()
endif ()
set(SRC include/android_jvm.h src/android_jvm.cpp)
add_library(JAVA_JVM STATIC ${SRC})
target_include_directories(JAVA_JVM PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/include)
add_library(ocpn::java-jvm ALIAS JAVA_JVM)

=== libs/gdal/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.0)

if (TARGET ocpn::gdal)
    return ()
endif ()

set(SRC
    include/gdal/cpl_config.h
    include/gdal/gdal_priv.h
    include/gdal/cpl_conv.h
    include/gdal/cpl_csv.h
    include/gdal/ogr_api.h
    include/gdal/cpl_error.h
    include/gdal/ogr_attrind.h
    include/gdal/cpl_list.h
    include/gdal/cpl_minixml.h
    include/gdal/ogr_feature.h
    include/gdal/cpl_multiproc.h
    include/gdal/ogr_geometry.h
    include/gdal/cpl_odbc.h
    include/gdal/ogr_p.h
    include/gdal/ogr_core.h
    include/gdal/cpl_port.h
    include/gdal/cpl_string.h
    include/gdal/ogr_spatialref.h
    include/gdal/cpl_vsi.h
    include/gdal/ogrsf_frmts.h
    include/gdal/gdal.h
    include/gdal/gdal_frmts.h
    src/cpl_conv.cpp
    src/cpl_csv.cpp
    src/cpl_error.cpp
    src/cpl_findfile.cpp
    src/cpl_minixml.cpp
    src/cpl_path.cpp
    src/cpl_string.cpp
    src/cpl_vsisimple.cpp
    src/cplgetsymbol.cpp
    src/ograssemblepolygon.cpp
    src/ogrcurve.cpp
    src/ogrfeature.cpp
    src/ogrfeaturedefn.cpp
    src/ogrfielddefn.cpp
    src/ogrgeometry.cpp
    src/ogrgeometrycollection.cpp
    src/ogrgeometryfactory.cpp
    src/ogrlinearring.cpp
    src/ogrlinestring.cpp
    src/ogrmultilinestring.cpp
    src/ogrmultipoint.cpp
    src/ogrmultipolygon.cpp
    src/ogrpoint.cpp
    src/ogrpolygon.cpp
    src/ogrlayer.cpp
    src/ogrutils.cpp
    src/gdal_misc.cpp
)

add_library(GDAL STATIC ${SRC})
add_library(ocpn::gdal ALIAS GDAL)

if ("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang|GNU")  # Apple is AppleClang
  target_compile_options(GDAL PRIVATE -fvisibility=default -fPIC)
endif ()

target_include_directories(GDAL BEFORE
  PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}/include
    ${CMAKE_CURRENT_SOURCE_DIR}/include/gdal
)

=== libs/gui/CMakeLists.txt ===
#[[
Copyright (C) 2025 by NoCodeHummel
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the
Free Software Foundation, Inc.,
51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,  USA.
#]]

# OpenCPN UI components library
# with dependency on Android utils.
cmake_minimum_required(VERSION 3.15.0)
set(CMAKE_CXX_STANDARD 17)

if (TARGET ocpn::guilib)
    return ()
endif ()

# Sources
set(SRC
    include/button_switch.h
    include/dialog_alert.h
    include/dialog_base.h
    include/dialog_footer.h
    include/dialog_input.h
    include/field_switch.h
    include/field_text.h
    include/edit_button.h
    include/expand_icon.h
    include/expand_panel.h
    include/form_grid.h
    include/svg_button.h
    include/svg_icons.h
    include/text_entry.h
    include/ui_utils.h
    src/button_switch.cpp
    src/dialog_alert.cpp
    src/dialog_base.cpp
    src/edit_button.cpp
    src/expand_icon.cpp
    src/expand_panel.cpp
    src/dialog_input.cpp
    src/field_switch.cpp
    src/field_text.cpp
    src/form_grid.cpp
    src/svg_button.cpp
    src/svg_icons.cpp
    src/text_entry.cpp
    src/ui_utils.cpp
)

add_library(GUILIB STATIC ${SRC})
add_library(ocpn::guilib ALIAS GUILIB)

if ("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang|GNU")  # Apple is AppleClang
  target_compile_options(
    GUILIB PRIVATE
      -fvisibility=default -Wno-unknown-pragmas -fPIC
  )
endif ()

target_include_directories(GUILIB PRIVATE ${wxWidgets_INCLUDE_DIRS})
target_link_libraries(GUILIB PRIVATE ${wxWidgets_LIBRARIES})
target_link_libraries(GUILIB PRIVATE ocpn::filesystem)
if (TARGET ocpn::wxsvg)
   target_link_libraries(GUILIB PRIVATE ocpn::wxsvg)
endif ()

target_include_directories(
  GUILIB PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/include
)

=== libs/iso8211/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.0)

# FIXME: the s57.h header depends on S57ClassRegistrar, not in model.

if (TARGET ocpn::iso8211)
    return ()
endif ()

if (NOT CMAKE_MODULE_PATH)
  set (CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/../../cmake)
endif ()

SET(SRC
    include/iso8211.h
    src/ddffield.cpp
    src/ddffielddefn.cpp
    src/ddfmodule.cpp
    src/ddfrecord.cpp
    src/ddfrecordindex.cpp
    src/ddfsubfielddefn.cpp
    src/ddfutils.cpp
)

add_library(ISO8211 STATIC ${SRC})
add_library(ocpn::iso8211 ALIAS ISO8211)

if ("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang|GNU")  # Apple is AppleClang
  target_compile_options(ISO8211 PRIVATE -fvisibility=default -fPIC)
endif ()

target_include_directories(ISO8211 PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/include)

target_link_libraries(ISO8211 PRIVATE ocpn::gdal)
target_link_libraries(ISO8211 PRIVATE ocpn::model)

=== libs/libdnet/CMakeLists.txt ===
# ~~~
# Include the libdnet library from https://github.com/ofalk/libdnet
#
# Exports: ocpn::dnet transitive link target
#
# License:      GPLv3+
# Copyright (c) 2023 Alec Leamas
# ~~~

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.

cmake_minimum_required(VERSION 3.10.0)

if (TARGET ocpn::dnet)
  return ()
endif ()

cmake_policy(SET CMP0026 NEW)
if (POLICY CMP0135)
  cmake_policy(SET CMP0135 NEW)
endif ()

include(ExternalProject)
set(LIBDNET_SRC ${CMAKE_BINARY_DIR}/libdnet-src)
if (APPLE)
  if (DEFINED CMAKE_OSX_ARCHITECTURES
      AND NOT CMAKE_OSX_ARCHITECTURES STREQUAL ""
  )
    string(REPLACE ";" "$<SEMICOLON>" DNET_ARCHS "${CMAKE_OSX_ARCHITECTURES}")
    set(CMAKE_ADDITIONAL_PARAMS "-DCMAKE_OSX_ARCHITECTURES='${DNET_ARCHS}'")
  endif ()
endif ()

if (CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
  add_compile_definitions(_CRT_SECURE_NO_WARNING)
  add_compile_options(/wd4996)
endif ()

set(
  LIBDNET_PATCH
  ${CMAKE_CURRENT_SOURCE_DIR}/config.h.in-Fix-wrong-return-type.patch
)
ExternalProject_Add(
  _libdnet EXCLUDE_FROM_ALL
  DOWNLOAD_COMMAND
      ${CMAKE_COMMAND} -E copy_directory
      ${CMAKE_CURRENT_SOURCE_DIR}/libdnet-libdnet-1.18.0  ${LIBDNET_SRC}
  UPDATE_COMMAND ""
  PATCH_COMMAND
      ${CMAKE_COMMAND} -Dpatch:FILEPATH=${LIBDNET_PATCH}
      -P ${CMAKE_CURRENT_SOURCE_DIR}/cmake/PatchFile.cmake
  CMAKE_ARGS
      -G${CMAKE_GENERATOR}
      -DCMAKE_INSTALL_PREFIX=${CMAKE_BINARY_DIR}/libdnet-src/installed
      -DCMAKE_INSTALL_LIBDIR=lib
      -DCMAKE_INSTALL_INCLUDEDIR=include
      -DCMAKE_INSTALL_DATADIR=share
      ${CMAKE_ADDITIONAL_PARAMS}
  SOURCE_DIR "${LIBDNET_SRC}"
  TEST_COMMAND ""
  INSTALL_COMMAND
      cmake --build . --target install --config $<CONFIG>
)
message(STATUS "Using patched libdnet at ${CMAKE_BINARY_DIR}/libdnet")

if (WIN32)
  set(_DNET_LIB ${LIBDNET_SRC}/installed/lib/dnet.lib)
else ()
  set(_DNET_LIB ${LIBDNET_SRC}/installed/lib/libdnet.a)
endif ()

add_custom_target(
  _dnet_build
  COMMAND  ${CMAKE_COMMAND} -E echo "Built the libdnet library"
  DEPENDS _libdnet
  BYPRODUCTS ${_DNET_LIB}
)

add_library(_DNET_IF INTERFACE)
add_library(ocpn::dnet ALIAS _DNET_IF)
add_dependencies(_DNET_IF _dnet_build)
target_include_directories(
  _DNET_IF INTERFACE ${LIBDNET_SRC}/installed/include
  _DNET_IF INTERFACE ${LIBDNET_SRC}/installed/include/dnet
)
target_link_libraries(_DNET_IF INTERFACE ${_DNET_LIB})

=== libs/shapelib/CMakeLists.txt ===
# ~~~
# Add linkage to the shapelib library
#
# On hosts having the package installed in system locations found by
# cmake use the system code. If not, download sources from shapelib
# github site and apply patches.
#
# Exports: ocpn::shapelib transitive link target
#
# License:      GPLv3+
# Copyright (c) 2023 Alec Leamas
# ~~~

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.

cmake_minimum_required(VERSION 3.10.0)

if (TARGET ocpn::shapelib)
  return ()
endif ()

set(shapelib "https://github.com/OSGeo/shapelib")
set(src_url "${shapelib}/archive/refs/tags/v1.6.1.tar.gz")
set(src_hash MD5=ccdcabbc685eb575120fa3eb61003280)

list(APPEND patches
  0001-cmake-Add-guard-for-multiple-inclusions.patch
  0002-cmake-Make-BUILD_TESTING-an-option.patch
  0003-shapefil.h-Use-correct-include-gdal-cpol.h-path.patch
)

if (POLICY CMP0135)
  cmake_policy(SET CMP0135 NEW)
endif ()

list(PREPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/cmake)

add_library(_SHAPELIB_IF INTERFACE)
add_library(ocpn::shapelib ALIAS _SHAPELIB_IF)

#  Check for system lib and use it if found. Done.
#
find_package(Shapelib)
if (SHAPELIB_FOUND)
  message(STATUS "Using system shapelib ")
  target_link_libraries(_SHAPELIB_IF INTERFACE shapelib::shapelib)
  return ()
endif ()

# Download sources from github
#
if (${CMAKE_VERSION} VERSION_LESS 3.20)
  message(WARNING "Using downloaded sources requires cmake >= 3.20")
endif ()

if (POLICY CMP0169)
  # FetchContent_Populate cannot be used if NEW
  cmake_policy(SET CMP0169 OLD)
endif ()

include(FetchContent)
FetchContent_Declare(shapelib_src URL ${src_url} URL_HASH ${src_hash})
FetchContent_Populate(shapelib_src)
FetchContent_GetProperties(shapelib_src SOURCE_DIR src_dir)
message(STATUS "Using downloaded shapelib at ${src_dir}")

# Apply patches
#
foreach (patch ${patches})
  execute_process(
    COMMAND ${CMAKE_COMMAND}
      -Dpatch_file=${CMAKE_CURRENT_SOURCE_DIR}/patches/${patch}
      -Dpatch_dir=${src_dir}
      -P ${CMAKE_CURRENT_SOURCE_DIR}/cmake/PatchFile.cmake
    COMMAND ${CMAKE_COMMAND} -E echo "-- Applying patch ${patch}"
  )
endforeach ()

# Configure
#
if (NOT TARGET shp)
  set(BUILD_TESTING OFF CACHE BOOL "")
  set(BUILD_APPS OFF CACHE BOOL "")
  set(BUILD_SHARED_LIBS OFF CACHE BOOL "")
  set(USE_CPL OFF CACHE BOOL "")
  add_subdirectory(${src_dir} shapelib_dir)
endif ()
target_link_libraries(_SHAPELIB_IF INTERFACE shp)
target_include_directories(_SHAPELIB_IF INTERFACE "${src_dir}")

=== plugins/wmm_pi/CMakeLists.txt ===
# ---------------------------------------------------------------------------
# Author:      nohal aka. Pavel Kalian Copyright: License:     wxWidgets License
# ---------------------------------------------------------------------------

# define minimum cmake version
cmake_minimum_required(VERSION 3.10)
cmake_policy(SET CMP0043 NEW)

project(wmm_pi)

set(PACKAGE_NAME wmm_pi)
set(VERBOSE_NAME Wmm)
set(TITLE_NAME WMM)
set(CPACK_PACKAGE_CONTACT "Pavel Kalian")

set(VERSION_MAJOR "1")
set(VERSION_MINOR "1")
set(VERSION_PATCH "2")
set(VERSION_DATE "12/09/2019")

if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE
      Release
      CACHE
        STRING
        "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
        FORCE
  )
endif (NOT CMAKE_BUILD_TYPE)


if (APPLE)
  include_directories(${CMAKE_SOURCE_DIR}/buildosx/include)
elseif (QT_ANDROID)
  include_directories(${CMAKE_SOURCE_DIR}/android)
endif ()

message(STATUS "Build type: ${CMAKE_BUILD_TYPE}")

# SET(CMAKE_BUILD_TYPE Debug)
set(CMAKE_MACOSX_RPATH "ON")

include("cmake/PluginConfigure.cmake")

set(SRC_WMM
    src/wmm_pi.h
    src/wmm_pi.cpp
    src/MagneticPlotMap.h
    src/MagneticPlotMap.cpp
    src/icons.h
    src/icons.cpp
    src/GeomagnetismHeader.h
    src/GeomagnetismLibrary.c
    src/EGM9615.h
    src/WmmUIDialog.h
    src/WmmUIDialog.cpp
    src/pi_TexFont.cpp
    src/pi_TexFont.h
    src/pi_ocpndc.cpp
    src/pi_ocpndc.h
)

if (QT_ANDROID)
  set(SRC_WMM ${SRC_WMM} src/pi_shaders.h)
  set(SRC_WMM ${SRC_WMM} src/pi_shaders.cpp)
endif (QT_ANDROID)

add_library(${PACKAGE_NAME} SHARED ${SRC_WMM})

target_include_directories(
  ${PACKAGE_NAME} BEFORE PRIVATE ${CMAKE_CURRENT_LIST_DIR}/include
)
target_link_libraries(${PACKAGE_NAME} PUBLIC ocpn::opencpn)

if ("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang|AppleClang")
  target_compile_options(
    ${PACKAGE_NAME} PRIVATE -Wno-unknown-pragmas -Wno-overloaded-virtual
  )
elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
  target_compile_options( ${PACKAGE_NAME} PRIVATE -Wno-unknown-pragmas)
endif ()

if (NOT QT_ANDROID)
  target_link_libraries(
    ${PACKAGE_NAME}
      PRIVATE ${wxWidgets_LIBRARIES} ocpn::wxjson  ocpn::gl-headers
  )
else (NOT QT_ANDROID)
  target_link_libraries(
    ${PACKAGE_NAME}
    PRIVATE ocpn::wxjson
            "-lGLESv1_CM"
            "-lGLESv2"
            ${Qt_Base}/${Qt_Build}/lib/libQt5Gui.so
            ${Qt_Base}/${Qt_Build}/lib/libQt5Core.so
            ${Qt_Base}/${Qt_Build}/lib/libQt5Widgets.so
            ${Qt_Base}/${Qt_Build}/lib/libQt5AndroidExtras.so
            ${CMAKE_CURRENT_BINARY_DIR}/../../libgorp.so
  )
  set(CMAKE_SHARED_LINKER_FLAGS "-Wl,-soname,lib${PACKAGE_NAME}.so ")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-s")
endif (NOT QT_ANDROID)

if (WIN32)
  target_link_libraries(${PACKAGE_NAME} PRIVATE "GLU_static")
endif (WIN32)

if (APPLE)
  target_compile_options(
    ${PACKAGE_NAME}
    PRIVATE "-Wall"
            "-Wno-unused"
            "-fexceptions"
            "-Wno-overloaded-virtual"
            "-Wno-deprecated"
            "-Wno-deprecated-declarations"
            "-Wno-unknown-pragmas"
            "-D_WCHAR_H_CPLUSPLUS_98_CONFORMANCE_"
  )
endif (APPLE)

# target_link_libraries(${PACKAGE_NAME} ocpn::opencpn )
target_link_libraries(${PACKAGE_NAME} PRIVATE ocpn::manual)

# Copy shared library to execution folder for debugging if not CI build
if (NOT OCPN_CI_BUILD)
  if (MSVC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /Zi")
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /DEBUG /OPT:REF /OPT:ICF")
    add_custom_command(
      TARGET ${PACKAGE_NAME}
      POST_BUILD
      COMMAND ${CMAKE_COMMAND} -E echo "Copying dll file"
      COMMAND ${CMAKE_COMMAND} -E echo "$<TARGET_FILE:${PACKAGE_NAME}>"
                "${CMAKE_BINARY_DIR}/$<CONFIGURATION>/plugins/${PACKAGE_NAME}.dll"
      COMMAND ${CMAKE_COMMAND} -E copy_if_different "$<TARGET_FILE:${PACKAGE_NAME}>"
                "${CMAKE_BINARY_DIR}/$<CONFIGURATION>/plugins/${PACKAGE_NAME}.dll"
    )
    add_custom_command(
      TARGET ${PACKAGE_NAME}
      POST_BUILD
      COMMAND ${CMAKE_COMMAND} -E echo "Copying pdb file"
      COMMAND ${CMAKE_COMMAND} -E echo "$<TARGET_PDB_FILE:${PACKAGE_NAME}>"
                "${CMAKE_BINARY_DIR}/$<CONFIGURATION>/plugins/${PACKAGE_NAME}.pdb"
      COMMAND ${CMAKE_COMMAND} -E copy_if_different "$<TARGET_PDB_FILE:${PACKAGE_NAME}>"
                "${CMAKE_BINARY_DIR}/$<CONFIGURATION>/plugins/${PACKAGE_NAME}.pdb"
    )
  endif (MSVC)
endif (NOT OCPN_CI_BUILD)

include("cmake/PluginInstall.cmake")
include("cmake/PluginLocalization.cmake")
include("cmake/PluginPackage.cmake")

=== libs/mdns/mdns-1.4.3/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(mdns VERSION 1.4.2 LANGUAGES C)

option(MDNS_BUILD_EXAMPLE "build example" ON)

# Set the output of the libraries and executables.
set(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)
set(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/lib)

# ##############################################################################
# library
# ##############################################################################

add_library(${PROJECT_NAME} INTERFACE)
target_include_directories(
  ${PROJECT_NAME} INTERFACE $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/>
                            $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)
if(WIN32)
  target_link_libraries(${PROJECT_NAME} INTERFACE iphlpapi ws2_32)
endif()
add_library(${PROJECT_NAME}::${PROJECT_NAME} ALIAS ${PROJECT_NAME})
target_compile_features(${PROJECT_NAME} INTERFACE c_std_99)

# ##############################################################################
# example
# ##############################################################################

if(MDNS_BUILD_EXAMPLE)
  add_executable(${PROJECT_NAME}_example mdns.c)
  target_link_libraries(${PROJECT_NAME}_example ${PROJECT_NAME})
endif()

# ##############################################################################
# install
# ##############################################################################

include(GNUInstallDirs)

install(
  TARGETS ${PROJECT_NAME}
  EXPORT ${PROJECT_NAME}_Targets
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

include(CMakePackageConfigHelpers)
if(${CMAKE_VERSION} VERSION_LESS 3.14)
  write_basic_package_version_file(
    "${PROJECT_NAME}ConfigVersion.cmake"
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY SameMajorVersion)
else()
  write_basic_package_version_file(
    "${PROJECT_NAME}ConfigVersion.cmake"
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY SameMajorVersion
    ARCH_INDEPENDENT)
endif()

configure_package_config_file(
  "${PROJECT_SOURCE_DIR}/cmake/Config.cmake.in"
  "${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake" INSTALL_DESTINATION
  ${CMAKE_INSTALL_DATAROOTDIR}/cmake/${PROJECT_NAME})

install(
  EXPORT ${PROJECT_NAME}_Targets
  FILE ${PROJECT_NAME}Targets.cmake
  NAMESPACE ${PROJECT_NAME}::
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/cmake/${PROJECT_NAME})

install(FILES "${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
              "${PROJECT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake"
        DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/cmake/${PROJECT_NAME})

install(FILES "${PROJECT_SOURCE_DIR}/mdns.h" DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

=== libs/ShapefileCpp/ShapeFileCpp-b2681f8/lib/CMakeLists.txt ===
project(ShapefileCppLib)

set(ShapefileCppLib_SOURCES
	src/ShapefileReader.cpp
	src/ShapefileWriter.cpp
	src/Schema.cpp
	src/FeatureIterator.cpp
	src/GeometryType.cpp
	src/Bounds.cpp
	src/Geometry.cpp
	src/Point.cpp
	src/Line.cpp
	src/Ring.cpp
	src/Polygon.cpp
	src/MultiPoint.cpp
	src/MultiLine.cpp
	src/MultiPolygon.cpp
	src/Feature.cpp
	src/FieldType.cpp
	src/Field.cpp
)

add_library(ShapefileCppLib STATIC ${ShapefileCppLib_SOURCES})

target_include_directories(ShapefileCppLib
	PUBLIC include shapelib::shapelib
	PRIVATE src
)
target_link_libraries(ShapefileCppLib shapelib::shapelib)

add_subdirectory(test)

=== libs/glshim/src/proxy/CMakeLists.txt ===
aux_source_directory(host HOST_SOURCES)
add_library(proxyhost SHARED EXCLUDE_FROM_ALL ${HOST_SOURCES})
target_link_libraries(proxyhost GL asound)

add_library(proxyhost_static STATIC EXCLUDE_FROM_ALL ${HOST_SOURCES})
set_target_properties(proxyhost_static PROPERTIES OUTPUT_NAME proxyhost)

add_subdirectory(client)
